#!/bin/sh

GENERAL_DIR=send_point
SIDE_DIR=send_point_side
MOBILE_DIR=send_point_mobile
ADMIN_DIR=dn

GENERAL_SRC=html/frontparts/bloc
MOBILE_SRC=html/mobile/frontparts/bloc

LOG=release.log

rm $LOG

for DIR in $GENERAL_DIR $SIDE_DIR $MOBILE_DIR $ADMIN_DIR
do
    if [ -f "$DIR".zip ] ; then
	rm "$DIR".zip
    fi
done

svn update 1>> $LOG

for DIR in $GENERAL_DIR $SIDE_DIR $MOBILE_DIR $ADMIN_DIR
do
    if [ ! -d $DIR ] ; then
	mkdir -p $DIR
    fi
done

cp $GENERAL_SRC/* $GENERAL_DIR
cp $GENERAL_SRC/dn.css $ADMIN_DIR
cp $GENERAL_SRC/index.php $ADMIN_DIR
cp $MOBILE_SRC/*  $MOBILE_DIR
cp $GENERAL_SRC/* $SIDE_DIR
patch -p3 -d $SIDE_DIR < sidebar.patch 1>> $LOG

find $SIDE_DIR -name '*.orig' | xargs rm -rf 1>> $LOG

for DIR in $GENERAL_DIR $SIDE_DIR $MOBILE_DIR $ADMIN_DIR
do
    if [ -d $DIR ] ; then
	zip -r "$DIR".zip $DIR 1>> $LOG
    fi
done

for DIR in $GENERAL_DIR $SIDE_DIR $MOBILE_DIR $ADMIN_DIR
do
    if [ -d $DIR ] ; then
	rm -rf $DIR
    fi
done